/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.alexaforbusiness.model;

import java.io.Serializable;
import javax.annotation.Generated;
import com.amazonaws.protocol.StructuredPojo;
import com.amazonaws.protocol.ProtocolMarshaller;

/**
 * <p>
 * Details of a device’s status.
 * </p>
 * 
 * @see <a href="http://docs.aws.amazon.com/goto/WebAPI/alexaforbusiness-2017-11-09/DeviceStatusDetail"
 *      target="_top">AWS API Documentation</a>
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class DeviceStatusDetail implements Serializable, Cloneable, StructuredPojo {

    /**
     * <p>
     * The device status detail code.
     * </p>
     */
    private String code;

    /**
     * <p>
     * The device status detail code.
     * </p>
     * 
     * @param code
     *        The device status detail code.
     * @see DeviceStatusDetailCode
     */

    public void setCode(String code) {
        this.code = code;
    }

    /**
     * <p>
     * The device status detail code.
     * </p>
     * 
     * @return The device status detail code.
     * @see DeviceStatusDetailCode
     */

    public String getCode() {
        return this.code;
    }

    /**
     * <p>
     * The device status detail code.
     * </p>
     * 
     * @param code
     *        The device status detail code.
     * @return Returns a reference to this object so that method calls can be chained together.
     * @see DeviceStatusDetailCode
     */

    public DeviceStatusDetail withCode(String code) {
        setCode(code);
        return this;
    }

    /**
     * <p>
     * The device status detail code.
     * </p>
     * 
     * @param code
     *        The device status detail code.
     * @return Returns a reference to this object so that method calls can be chained together.
     * @see DeviceStatusDetailCode
     */

    public DeviceStatusDetail withCode(DeviceStatusDetailCode code) {
        this.code = code.toString();
        return this;
    }

    /**
     * Returns a string representation of this object; useful for testing and debugging.
     *
     * @return A string representation of this object.
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        if (getCode() != null)
            sb.append("Code: ").append(getCode());
        sb.append("}");
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;

        if (obj instanceof DeviceStatusDetail == false)
            return false;
        DeviceStatusDetail other = (DeviceStatusDetail) obj;
        if (other.getCode() == null ^ this.getCode() == null)
            return false;
        if (other.getCode() != null && other.getCode().equals(this.getCode()) == false)
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int hashCode = 1;

        hashCode = prime * hashCode + ((getCode() == null) ? 0 : getCode().hashCode());
        return hashCode;
    }

    @Override
    public DeviceStatusDetail clone() {
        try {
            return (DeviceStatusDetail) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new IllegalStateException("Got a CloneNotSupportedException from Object.clone() " + "even though we're Cloneable!", e);
        }
    }

    @com.amazonaws.annotation.SdkInternalApi
    @Override
    public void marshall(ProtocolMarshaller protocolMarshaller) {
        com.amazonaws.services.alexaforbusiness.model.transform.DeviceStatusDetailMarshaller.getInstance().marshall(this, protocolMarshaller);
    }
}
